package com.biganto.visual.roompark.presentation.screen.feeds

import android.content.Context
import com.biganto.visual.roompark.base.RoomParkMainActivity
import com.biganto.visual.roompark.data.repository.api.retrofit.di.RetrofitModule
import com.biganto.visual.roompark.data.repository.db.requrey.DbModule
import com.biganto.visual.roompark.data.service.user_session.IUserSession
import com.biganto.visual.roompark.data.service.user_session.UserSessionService
import com.biganto.visual.roompark.di.dagger.AppComponent
import com.biganto.visual.roompark.di.dagger.AppModule
import com.biganto.visual.roompark.di.dagger.DataModule
import com.biganto.visual.roompark.di.dagger.PerScreen
import dagger.Binds
import dagger.BindsInstance
import dagger.Module
import dagger.Subcomponent


@PerScreen
@Subcomponent(
    modules = [FeedsScreenModule::class
        , DataModule::class
        , RetrofitModule::class
        , AppModule::class
        , DbModule::class]
//    ,dependencies = [AppComponent::class]
)
interface FeedsScreenComponent {

    @Subcomponent.Factory
    interface Factory{
        fun create(
            appComponent: AppComponent
            ,@BindsInstance activity: RoomParkMainActivity
        ): FeedsScreenComponent
    }

    val presenter: FeedsScreenPresenter

    fun inject(controller: FeedsScreenController)
}

@Module
abstract class FeedsScreenModule{

    @PerScreen
    @Binds
   abstract fun provideContext(activity: RoomParkMainActivity): Context

//    @PerScreen
//    @Binds
//    abstract fun provideContract(impl: FeedsContractModule): FeedsContract


    @PerScreen
    @Binds
    abstract fun provideSession(impl: UserSessionService): IUserSession

}
