package com.biganto.visual.roompark.presentation.screen.settings

import android.content.Context
import com.biganto.visual.roompark.base.RoomParkMainActivity
import com.biganto.visual.roompark.data.repository.api.retrofit.di.RetrofitModule
import com.biganto.visual.roompark.data.repository.db.requrey.DbModule
import com.biganto.visual.roompark.di.dagger.AppComponent
import com.biganto.visual.roompark.di.dagger.AppModule
import com.biganto.visual.roompark.di.dagger.DataModule
import com.biganto.visual.roompark.di.dagger.PerScreen
import dagger.Binds
import dagger.BindsInstance
import dagger.Module
import dagger.Subcomponent


@PerScreen
@Subcomponent(
    modules = [SettingsScreenModule::class, DataModule::class
        , RetrofitModule::class, AppModule::class, DbModule::class]
//    ,dependencies = [AppComponent::class]
    )
interface SettingsScreenComponent {

    @Subcomponent.Factory
    interface Factory{
        fun create(
            appComponent: AppComponent
            ,@BindsInstance activity: RoomParkMainActivity
        ): SettingsScreenComponent
    }

    val presenter: SettingsScreenPresenter

    fun inject(controller: SettingsScreenController)
}

@Module
abstract class SettingsScreenModule{

    @PerScreen
    @Binds
    abstract fun provideContext(activity: RoomParkMainActivity): Context

//    @PerScreen
//    @Binds
//    abstract fun provideAuth(contract: AuthContractModule): AuthContract

}
